# -*- coding: utf-8 -*-
import xbmc, xbmcgui, xbmcplugin, xbmcaddon, os, urllib, sys, urllib2, time
#nt=time.time()
PLUGIN_NAME   = 'plugin.program.pazl.epg'
handle = int(sys.argv[1])
addon = xbmcaddon.Addon(id='plugin.program.pazl.epg')
__settings__ = xbmcaddon.Addon(id='plugin.program.pazl.epg')

pazl = xbmcaddon.Addon(id='plugin.video.pazl2.tv')
sys.path.append(pazl.getAddonInfo('path'))
sys.path.append(xbmc.translatePath(os.path.join(xbmc.translatePath("special://masterprofile/"),"addon_data","plugin.video.pazl2.tv")))

UserDir = xbmc.translatePath(os.path.join(xbmc.translatePath("special://masterprofile/"),"addon_data","plugin.program.pazl.epg"))


try: 
	from UserDBcnl import *
except: 
	from DBcnl import *

try: 
	from EPGdb import *
	if EPG == "": EPG = {}
except:
	EPG = {}

#==================================================================================================

def getURL(url, Referer = 'http://viks.tv/'):
	req = urllib2.Request(url)
	req.add_header('User-Agent', 'Opera/10.60 (X11; openSUSE 11.3/Linux i686; U; ru) Presto/2.6.30 Version/10.60')
	req.add_header('Accept', 'text/html, application/xml, application/xhtml+xml, */*')
	req.add_header('Accept-Language', 'ru,en;q=0.9')
	req.add_header('Referer', Referer)
	response = urllib2.urlopen(req)
	link=response.read()
	response.close()
	return link

def save_d(d):
	try:
		fp=xbmc.translatePath(os.path.join(UserDir, 'epg.db'))
		fl = open(fp, "w")
		fl.write(repr(d))
		fl.close()
	except:
		pass

def get_d():
	try:
		fp=xbmc.translatePath(os.path.join(UserDir, 'epg.db'))
		fl = open(fp, "r")
		d=eval(fl.read())
		fl.close()
		return d
	except:
		return {}
link_cnl = get_d()

def mfindal(http, ss, es):
	L=[]
	while http.find(es)>0:
		s=http.find(ss)
		#sn=http[s:]
		e=http.find(es)
		i=http[s:e]
		L.append(i)
		http=http[e+2:]
	return L

def mfind(t,s,e):
	r=t[t.find(s)+len(s):]
	r2=r[:r.find(e)]
	return r2


def add_item (name, mode="", ind="0", cover=None, funart=None):

	listitem = xbmcgui.ListItem(name, iconImage=cover)
	uri = sys.argv[0] + '?mode='+mode
	uri += '&name='  + urllib.quote_plus(name)
	uri += '&ind='  + urllib.quote_plus(str(ind))
	
	Context=[('[COLOR FF55FF55][B]Связать с каналом...[/B][/COLOR]', 'Container.Update("plugin://plugin.program.pazl.epg/?mode=set_id&ind='+ind+'")'),]
	listitem.addContextMenuItems(Context)
	
	xbmcplugin.addDirectoryItem(handle, uri, listitem, True)#False

def get_nm_dict():
	nm_dict={}
	for i in EPG.keys():
		try:nm_dict[EPG[i]['title']]=i
		except:pass
	return nm_dict

def root():
	D=get_nm_dict()
	link_epg={}
	for k in link_cnl.keys():
		link_epg[link_cnl[k]]=k
	for i in D.keys():
			pid=D[i]
			if pid in DBC.keys(): title='[COLOR FF55ff55]'+i+'[/COLOR] ['+DBC[pid]['title']+']'
			elif pid in link_epg.keys(): title='[COLOR FF55ff55]'+i+'[/COLOR] ['+DBC[link_epg[pid]]['title']+']'
			else: title='[COLOR FFFF5555]'+i+'[/COLOR] [НЕ СВЯЗАН]'
			add_item(title, "all", pid)#set_id
		
	xbmcplugin.addSortMethod(handle, xbmcplugin.SORT_METHOD_LABEL)
	xbmcplugin.endOfDirectory(handle)

def all(ind):
	port=__settings__.getSetting("serv_port")
	url='http://127.0.0.1:'+port+'/debug/'+ind
	ht=getURL(url)
	L=ht.splitlines()
	for i in L:
		add_item(i)
	xbmcplugin.endOfDirectory(handle)

def set_id(ind):
	#D=get_nm_dict()
	#title=D[ind]
	CL=sort_abc(DBC.keys())
	L2=[]
	for i in CL:
		L2.append(DBC[i]['title'])
	
	sel = xbmcgui.Dialog()
	r = sel.select("Связать телепрограмму с каналом:", L2)
	if r>-1:
		id=CL[r]
		#D[id]=title
		#D.pop(ind)
		#__settings__.setSetting('idlist', repr(D))
		port=__settings__.getSetting("serv_port")
		url='http://127.0.0.1:'+port+'/change/id='+id+'/to='+ind
		getURL(url)
		#if info != None:
		#	rem_inf_db(ind)
		#	add_to_db(id, info)
		xbmc.sleep(2000)
		xbmc.executebuiltin("Container.Refresh")

def sort_abc(L):
	L2=[]
	for id in L:
		try: L2.append((DBC[id]['title'],id))
		except: pass
	L2.sort()
	L=[]
	for i in L2:
		L.append(i[1])
	return L


#from DBcnl import *
def get_channels_info(cid):
	info=EPG[cid]
	
	try:L=info.keys()
	except:
		print 'info err:'
		print info
		return []
		
	try:L.remove('title')
	except: pass
	L.sort()
	if __settings__.getSetting('autoshift')=='true':
		dts=time.timezone
	else:
		dts=(int(__settings__.getSetting('shift'))-11)*3600
	#print dts
	ct=time.time()
	m_ct=ct+dts
	#print ct
	for i in L:
		#print i
		try:ei=eval(i)-3*60*60
		except:
			print '!except eval(i)!'
			ei=0
		if ei > m_ct:
			#print 'ok'
			n1=L.index(i)
			n0=n1-1
			n2=n1+1
			e1=info[L[n1]]
			e1['time']=str(eval(L[n1])-3*60*60-dts)
			if n0>=0: 
				e0=info[L[n0]]
				e0['time']=str(eval(L[n0])-3*60*60-dts)
			else:e0={}
			if n2<len(L): 
				e2=info[L[n2]]
				e2['time']=str(eval(L[n2])-3*60*60-dts)
			else:e2={}
			Lr=[e0,e1,e2]
			#print Lr
			return Lr
	
	#if 'title' in info.keys():title=info['title']
	#else:title='Неизвестный канал'
	#print "NoEPG " +cid+' '+title
	return []

def get_all_current_epg():
	D={}
	for cid in EPG.keys():
			#print cid
			if cid!='udata':
				nfo=get_channels_info(cid)
				D[cid]=nfo
	return D

def current():
	D=get_all_current_epg()
	for i in D.keys():
			listitem = xbmcgui.ListItem(i)
			uri = sys.argv[0] + '?data='+repr(D[i])
			xbmcplugin.addDirectoryItem(handle, uri, listitem, True)
	xbmcplugin.endOfDirectory(handle)

def get_params():
	param=[]
	paramstring=sys.argv[2]
	if len(paramstring)>=2:
		params=sys.argv[2]
		cleanedparams=params.replace('?','')
		if (params[len(params)-1]=='/'):
			params=params[0:len(params)-2]
		pairsofparams=cleanedparams.split('&')
		param={}
		for i in range(len(pairsofparams)):
			splitparams={}
			splitparams=pairsofparams[i].split('=')
			if (len(splitparams))==2:
				param[splitparams[0]]=splitparams[1]
	return param

params = get_params()

try:mode = urllib.unquote_plus(params["mode"])
except:mode =""
try:name = urllib.unquote_plus(params["name"])
except:name =""
try:url = eval(urllib.unquote_plus(params["url"]))
except:url =[]
try:cover = urllib.unquote_plus(params["cover"])
except:cover =""
try:ind = urllib.unquote_plus(params["ind"])
except:ind ="0"
	
if mode==""         : root()
if mode=="set_id"   : set_id(ind)
if mode=="all"      : all(ind)
if mode=="get"      : current()
	
	
#'https://tv.mail.ru/ajax/event/?id=92965136&region_id=70'